int led_pin = 11;
// Define a 10-byte integer data variable cmd as a command, where you can modify for different numbers. Here is set to 10 in order to have better compatibility.
char cmd [10];
// determine whether the received content
bool valid_cmd = false;
 
void setup ()
{
    // Define the connection led pin as an output signal
    pinMode (led_pin, OUTPUT);
    Serial.begin (9600);
}
void loop ()
{
    /* The following section is the serial information processing */
    // Define an integer variable i
    int i;
    // If the serial data received
    if (Serial.available ()> 0)
    {
        // Variable i is a maximum of 10
        for (i = 0; i <10; i ++)
        {
        // Empty the cache, stored in cmd variable, and \ 0 as the terminator
            cmd [i] = '\ 0';
        }  
        // This time i can only take front nine, is the end of the first 10 characters \ 0
        for (i = 0; i <9; i ++)
        {  
            // Determines again if you receive serial data, prevent data loss
            if (Serial.available ()> 0)
            {
                // Assigned to the variable cmd, former nine characters take serial received
                cmd [i] = Serial.read ();
                delay (1);
            }
            else
            {
                // If the serial data over 9, the following character simply ignored, skip to the next step
                break;
            }
        }
    /* The above information processing serial end */
   
        // Get the final variable cmd of RMS
        valid_cmd = true;
    }
   
    // Determine the value of the variable cmd, start processing
    if (valid_cmd)
    {
        // Before the two values ​​if the variable cmd is on
        if (0 == strncmp (cmd, "on", 2))
        {
            // Led the connection pin voltage is set high 5V,
            digitalWrite (led_pin, HIGH);
            // Return value serial printer ON, indicates ON operation is executed successfully
            Serial.println ("ON");
        }
        else if (0 == strncmp (cmd, "off", 3)) // Otherwise, if the value before the three variable cmd is off
        {
            // The pin voltage relay connection is set low 0V, the circuit is broken lamp, lamp
            digitalWrite (led_pin, LOW);
            // Serial print return value F, indicates OFF operation is executed successfully
            Serial.println ("OFF");
        }
        else // If these two conditions are not established, the first two are not ON, or the front three are not OFF, that is not the correct command
        {
            // Print only the serial port Return value X, indicates an instruction error.
            Serial.println ("X");
        }
        // This variable cmd command been processed
        valid_cmd = false;
    }
    // Delay 10 milliseconds, return the main program loop to continue to read the new serial command
    delay (10);
 
}

